// src/index.ts
function stringInterpolation(s, v, {
  pattern: p = new RegExp(/\{{([^{]+)}}/g),
  sanity: S = true,
  raw: r = false
} = {}) {
  if (!s && S)
    throw "Empty string";
  const sV = [...s.matchAll(p)];
  if (!sV[0])
    return s;
  if (S) {
    const k = Object.keys(v);
    if (sV.length !== k.length)
      throw "Variable count mismatch";
    for (const _v of sV) {
      const vIs = _v[1];
      if (vIs && !k.includes(vIs))
        throw `Variable '${vIs}' not found`;
    }
  }
  const raw = s.split(p).filter(Boolean).map((_v) => {
    return v[_v] ? v[_v] : _v;
  });
  const j = !raw.filter(
    (i) => typeof i !== "string" && typeof i !== "number"
  )[0];
  if (j && !r)
    return raw.join("");
  return raw;
}
export {
  stringInterpolation
};
